//
//  SynchronizedDirectiveSample.m
//  iOSMultiThreadSample
//
//  Created by xiaoyong.cxy on 18/07/2017.
//  Copyright © 2017 maple. All rights reserved.
//

#import "SynchronizedDirectiveSample.h"

@interface SynchronizedDirectiveSample () {
    NSMutableArray *_arr;
}

@end

@implementation SynchronizedDirectiveSample

- (instancetype)init
{
    self = [super init];
    if (self) {
        _arr = [NSMutableArray array];
    }
    
    return self;
}

- (void)foo
{
    @synchronized (nil) {
        NSObject *obj = [[NSObject alloc] init];
        [_arr addObject:obj];
    }
}

- (void)bar
{
    @synchronized ([[NSObject alloc] init]) {
        NSObject *obj = [[NSObject alloc] init];
        [_arr addObject:obj];
    }
}

- (void)testSynchronizedRecursive
{
    // 系统应该使用了递归锁，所以不存在死锁
    @synchronized (self) {
        NSObject *obj = [[NSObject alloc] init];
        [_arr addObject:obj];
    }
}

- (void)exceptionWithSynchronized
{
    @synchronized (_arr) {
        [_arr removeObjectAtIndex:5];
    }
}

@end
